<?php

namespace Drupal\farm_multitenant\Service;

use Drupal\group\Entity\GroupInterface;
use Drupal\group\Entity\GroupRelationship;

class GroupHelper {

  /**
   * Get farm IDs associated with a specific group.
   */
  public function getGroupFarmIds(GroupInterface $group) {
    $farm_ids = [];

    // Query group relationships to find related farms.
    $query = \Drupal::entityQuery('group_relationship')
      ->accessCheck(TRUE)
      ->condition('gid', $group->id())
      ->condition('type', 'farm-group_organization-farm');

    $relationship_ids = $query->execute();

    if (!empty($relationship_ids)) {
      $relationships = GroupRelationship::loadMultiple($relationship_ids);

      foreach ($relationships as $relationship) {
        $farm_entity = $relationship->getEntity();
        if ($farm_entity && $farm_entity->getEntityTypeId() == 'organization') {
          $farm_ids[] = $farm_entity->id();
        }
      }
    }

    return $farm_ids;
  }
}
